/* 
Lab 1 - TDDE18 - Basic I/O
Last modification : 2020-09-02
*/

#include <iostream>
#include <iomanip>
#include <string>

using namespace std;

/*Comment:
Really good looking code. Well written and consistant syntax
Try to avoid comments on the same line as code and only use if it's
not obvious what that code is doing.

--> done: Removal of unnecessary comments, separation of code lines and comment lines.
*/

// A function to clean cin input
void clean() {
    cin.ignore(1000,'\n');
}

int main() {
    // List of authorized variables
    int integer{};
    char character{};
    double real{};
    string str{""};


    cout << "Enter one integer: ";
    cin >> integer;
    cout << "You entered the number: " << integer << "\n" <<endl;
    // Cleaning the buffer in case of the user gave more than 1 integer
    clean();

    cout << "Enter four integers: ";
    cin  >> integer;
    cout << "You entered the numbers: " << integer << " ";
    cin  >> integer;
    cout << integer << " ";
    cin  >> integer;
    cout << integer << " ";
    cin  >> integer;
    cout << integer << "\n" << endl;
    clean();

    cout << "Enter one integer and one real number: ";
    cin >> integer;
    cin >> real;
    // Here, we use setw() to force the width and setprecision() to force the number of decimals
    cout << "The real is: " << setw(10)
        << fixed << setprecision(3)
        << real << endl;
    cout << "The integer is: " << setw(7) << integer << "\n" << endl;
    clean();

    cout << "Enter one real and one integer number: ";
    cin >> real;
    cin >> integer;
    cout << "The real is: " << setw(10) << setfill('.') << fixed << setprecision(3) << real << endl;
    cout << "The integer is: " << setw(7) << setfill('.')
        << integer << "\n" << endl;
    clean();

    cout << "Enter a character: ";
    cin >> character;
    cout << "You entered: " << character << "\n" << endl;
    clean();

    cout << "Enter a word: ";
    cin >> str;
    cout << "The word '" << str << "' has " << str.length() << " character(s)." << "\n" << endl;
    clean();

    cout << "Enter an integer and a word: ";
    cin >> integer;
    cin >> str;
    cout << "You entered ’"<< integer <<"’ and ’" << str << "’." << "\n" << endl;
    clean();

    cout << "Enter an character and a word: ";
    cin >> character;
    cin >> str;
    cout << "You entered the string \"" << str << "\" and the character ’" << character << "’." << "\n" << endl;
    clean();

    cout << "Enter a word and a real number: ";
    cin >> str;
    cin >> real;
    cout << "You entered \"" << str << "\" and \"" << real << "\"." << "\n" << endl;
    clean();

    cout << "Enter a text-line: ";
    // Read the entire line (stop when it finds a \n)
    getline (cin, str);
    cout << "You entered: \"" << str << "\"\n" << endl;

    cout << "Enter a second line of text: ";
    getline (cin, str);
    cout << "You entered: \"" << str << "\"\n" << endl;

    cout << "Enter three words: ";
    cin  >> str;
    cout << "You entered: '" << str << " ";
    cin  >> str;
    cout << str << " ";
    cin  >> str;
    cout << str << "'" << endl;
    clean();

    return 0;
}
