#!/bin/bash

echo "Starting building..."
g++ -Wall -Wextra -Wpedantic -std=c++17 *.cc *.h -o out.o

if test $? -eq 0
then
	echo "Build finished. Running..."
	echo ""
	./out.o -s
	echo ""
	echo "Done. Cleaning..."
	rm out.o
	echo "Done."
else
	echo "Build failed."
fi

exit 0
